'import midifile 
'smf 0,1
'programme crit par NGUYEN.Chung
'
'MThd 4long=6 2typesmf=0,1,2 2nbtrk=1 2tempo=01,128:timecode
'MTrk 4long=long-22
'1,2si1>127Twait code chr1 chr2
' 255 system  chr2=nboctets  sauter chr1=81 tempo tt tt tt
' 144 noteon  chr1=note chr2=velocit
' 128 noteoff chr1=note chr2=offrate
' 176 control chr1=64sustain chr2=127on,0off
'             chr1=123allnoteoff chr2=0
'             chr1=07volume chr2=vol
' 160 polyaftertouch chr1=note chr2=valeur
' 192 progchange chr1=numprog
' 208 aftertouch chr1=valeur
' 224 pitch   chr1,chr2=valeur
' 242 songptr chr1,chr2=valeur
' 243 songselect chr1=numero
' 246 tunerequest
Type STATUSBYTE
  As Ubyte channel:4
  As Ubyte status :4
End Type

Type MIDIMESSAGE
  Union
  Type
  Union
  As STATUSBYTE Byte
  As Ubyte      byte0
  End Union
  As Ubyte      byte1
  As Ubyte      byte2
  As Ubyte      byte3
  End Type
  As Uinteger   value
  End Union
End Type

Dim Shared As Integer nrecord=200000,irecord
Dim Shared As MIDIMESSAGE recordmsg(nrecord),mymidimsg
Dim Shared As Double recordtime(nrecord),timenote,timerecord,timemidi
Sub dprintmsg(ByVal msg As String="")
'? msg
End Sub
Function inputfile(ByVal file As Integer,ByVal nchar As Integer)As String 
	Return input(nchar,#file)
End Function
Dim Shared As Integer canal=0,code=0,chr1=0,chr2=0,note=0,velocite=0
Sub addplaynoteoff()
If irecord<nrecord Then 
 irecord+=1
 timerecord=timemidi/1000.0
 recordtime(irecord)=timerecord
 recordmsg(irecord).byte.channel=canal
 recordmsg(irecord).byte.status=&H8
 recordmsg(irecord).byte1=note
 recordmsg(irecord).byte2=0
EndIf 
End Sub
Sub addplaynote()
If irecord<nrecord Then 
 irecord+=1
 timerecord=timemidi/1000.0
 recordtime(irecord)=timerecord
 recordmsg(irecord).byte.channel=canal
 recordmsg(irecord).byte.status=&H9
 recordmsg(irecord).byte1=note
 recordmsg(irecord).byte2=velocite
EndIf 	
End Sub
Sub outmidi2()
If irecord<nrecord Then 
 irecord+=1
 timerecord=timemidi/1000.0
 recordtime(irecord)=timerecord
 recordmsg(irecord).byte.channel=canal
 recordmsg(irecord).byte.status=code Shr 4
 recordmsg(irecord).byte1=chr1
 recordmsg(irecord).byte2=chr2
EndIf 	
End Sub
Sub importmidi(ByRef fic As String)
Var itrkmax=100
dim as string  trkchar(itrkmax)
dim As double ttk(itrkmax),tt,tt1
dim As Integer jtrk(itrkmax),itrkk(itrkmax),trkk(itrkmax)
dim As Integer code240k(itrkmax),canal15k(itrkmax)

Dim As Integer file,i,j,k,n,erreur
Dim As String ficin,auxchar,MThd
If fileexists(fic)=0 Then guinotice fic+" not found !":Exit sub
file=FreeFile 
open fic for Binary Access Read as #file
Var openficin=1
Var Lficin=lof(file)
ficin=inputfile(file,Lficin)
close #file
openficin=0
n=instr(ficin,"MThd")
if n<1 then guinotice fic+"  MThd non trouv":Exit Sub
file=FreeFile
open fic for Binary Access Read as #file
openficin=1
if n>1 then auxchar=inputfile(file,n-1)

'dprintmsg #win.long,using("####.#",Lficin/1000)&" k"

dprintmsg "Lficin=" &Lficin

if Lficin<22 then
  guinotice fic+"  Lficin<22"
  Close #file:Exit Sub 
end If


MThd=inputfile(file,4)
Var lthd=0
for i=1 to 4
lthd=lthd*256+asc(inputfile(file,1))
next i

Var typesmf=0
for i=1 to 2
typesmf=typesmf*256+asc(inputfile(file,1))
next i

dprintmsg MThd &" " &lthd &" typesmf:" &typesmf

if MThd<>"MThd" or typesmf>1 then
 guinotice "mauvais fichier MThd="+MThd _
       +"  typesmf="+str$(typesmf)+" requis smf=0,1"
 Close #file:Exit sub
end if

auxchar=inputfile(file,1)
Dim As Integer nbtempo,typetempo,nbtrk
nbtrk=asc(auxchar)*256+asc(inputfile(file,1))
nbtempo=asc(inputfile(file,1))
typetempo=asc(inputfile(file,1))
dprintmsg "nbtrk:"&nbtrk
dprintmsg "typetempo:" &nbtempo &"," &typetempo

if nbtrk>itrkmax then
 guinotice "mauvais fichier nbtrk="+str$(nbtrk)+" max="+str$(itrkmax)
 Close #file:Exit Sub 
end if
Dim As Double tempo2,tempo3,tempo30,tempo4,auxt0,t
tempo3=1/(typetempo+256*nbtempo) 'nb ticks/noire
tempo30=tempo3
auxt0=500000 'duree noire microsec
tempo2=1000*tempo3*auxt0/1000000 'duree tick ms
Var ssss="",tempo2i=0,metro2i=0
tempo4=1.0'100/max(10,tempo(ific))

redim trkchar(itrkmax)
Dim As Integer itrk=0,ltrk=0
while eof(file)=0 and itrk<nbtrk
itrk=itrk+1
Var Mtrkchar=inputfile(file,4)
ltrk=0
For i=1 to 4
ltrk=ltrk*256+asc(inputfile(file,1))
next i

trkchar(itrk)=inputfile(file,ltrk)

dprintmsg Mtrkchar &"=" &itrk &"  ltrk=" &ltrk &" " &len(trkchar(itrk))

if Mtrkchar<>"MTrk" then
 guinotice "mauvais fichier  Mtrkchar="+Mtrkchar
 Close #file:Exit Sub
end if

wend

if eof(file)<>0 then dprintmsg "eof"

close #file
openficin=0

i=0:irecord=0:timemidi=0
/'
erreur=0:nberreur=0
inoteoff=0
inoteoff0=0
redim play(128,16)
redim tnoteon(128,16)
for canal=0 to 15:volcanal(canal)=1:next canal

redim ttk(itrkmax)
redim jtrk(itrkmax):redim trkk(itrkmax)
redim itrkk(itrkmax)
redim code240k(itrkmax):redim canal15k(itrkmax)
'/
for itrk=1 to nbtrk
    ttk(itrk)=0
    trkk(itrk)=len(trkchar(itrk))
    itrkk(itrk)=itrk
next itrk
'ttime=time$("ms")
'tt=ttime
'tt0=tt
Dim As Integer nbtrk0,auxtrk0
nbtrk0=nbtrk
itrk=1:auxtrk0=1
ltrk=trkk(1)
/'tt1=tt+10000
tt2=tt-1000
tt3=tt
tfin=tt:ttoff=tt+1000000
play=0:play0=0:playoff=0
itot=0
surcharge=0:allnoteoff=0:offset=0
itest=0
nbnote=0:redim nbnote(16)
volume=40
'/
Dim As Integer itot=0,code240=0,canal15=0,code2400=0,canal150=0,inconnu=0,vu=0
Dim As Integer offset=0,allnoteoff=0,nberreur=0,code0=0
Dim As Double ttitrk=0,ttitrk0=0
dim as integer instrument,instrcanal(16)
dim as integer i0,auxt,auxtrk=0
t=0:tt=0

nextchunk:

i0=i:i=i+1
auxt=asc(mid$(trkchar(itrk),i,1))
t=auxt and 127
while auxt>127
  i=i+1
  auxt=asc(mid$(trkchar(itrk),i,1))
  t=t*128+(auxt and 127)
wend
'tt=tt+t*tempo2*tempo4
if t=0 and i0>0 then goto suitetrk 'meme piste

itot=itot+i-jtrk(itrk)
ttitrk0=ttk(itrk)
ttitrk=ttitrk0+t
ttk(itrk)=ttitrk
jtrk(itrk)=i
code240k(itrk)=code240
canal15k(itrk)=canal15

nexttrk:
auxtrk=0
for auxtrk=1 to nbtrk
    if ttk(itrkk(auxtrk))<ttitrk then
       itrk=itrkk(auxtrk):ttitrk=ttk(itrk):auxtrk0=auxtrk
    end if
next auxtrk
i=jtrk(itrk)
code240=code240k(itrk)
canal15=canal15k(itrk)
if i=0 then goto nextchunk
ltrk=trkk(itrk)


tt=tt+(ttitrk-ttitrk0)*tempo2*tempo4


suitetrk:
timemidi=tt

nextcode:
'nbnote0=nbnote
'tt3=time$("ms")

i=i+1
code2400=code240
canal150=canal15
auxchar=mid$(trkchar(itrk),i,1)
code=asc(auxchar)
code240=code and 240
canal15=code and 15
canal=canal15
inconnu=1

if code<=127 then
   'itest=itest+1
   inconnu=0
   i=i+1
'   chr1$=mid$(trkchar(itrk),i,1)
   chr2=asc(mid$(trkchar(itrk),i,1))
   note=code
   code240=code2400
   canal15=canal150
   canal=canal15
   velocite=chr2 and 127
   code=code240+canal15
   if (velocite=0 and code240=144) or code240=128 then
      addplaynoteoff()
   else
    if code240=144 then
      addplaynote()
    else
     vu=0
     if code240=176 then 'control
        if note=64 or note=123 then 'sustain allnoteoff
           If note=123 then
              allnoteoff=allnoteoff+1
              /'nbnote=nbnote-nbnote(canal)
              for auxnote=1 to 127
                  if play(auxnote,canal)>0 then
                     outmidi=0+auxnote*256+128+canal
                     gosub [outmidi] 'par securite
                     play(auxnote,canal)=0
                  end if
              next auxnote
              nbnote(canal)=0 '/
           end if 
           'outmidi=chr2*256*256+note*256+code
           chr1=note
           outmidi2()
           vu=1
        end if
     end if
     if vu=0 then
        erreur=erreur+1
       ' erreur$="erreur=" &erreur &"  code=" &code240 &"  note=" &note &" velo=" &chr2
       ' dprintmsg erreur$
     end if
    end if
   end if
   if i<ltrk then goto nextchunk:
end if

if code240=144 then 'noteon
   inconnu=0
   i=i+1
   chr1=asc(mid$(trkchar(itrk),i,1))
   i=i+1
   chr2=asc(mid$(trkchar(itrk),i,1))
   note=chr1 and 127
   velocite=chr2 and 127
   if velocite=0 then
      addplaynoteoff()
   else
      addplaynote()
   end if
   if i<ltrk then goto nextchunk:
end if

if code240=128 then 'noteoff
   inconnu=0
   i=i+1
   chr1=asc(mid$(trkchar(itrk),i,1))
   i=i+1
   chr2=asc(mid$(trkchar(itrk),i,1))
   note=chr1 and 127
   velocite=0 'chr2
   addplaynoteoff()
   if i<ltrk then goto nextchunk:
end if

if code=255 then 'system
   inconnu=0
   i=i+1
   chr1=asc(mid$(trkchar(itrk),i,1))
   i=i+1
   chr2=asc(mid$(trkchar(itrk),i,1))
   vu=0
   if chr1=81 and chr2=3 then  'tempo
      tempo2i=tempo2i+1
      vu=1
      i=i+1
      auxt=asc(mid$(trkchar(itrk),i,1))*256*256
      i=i+1
      auxt=auxt+asc(mid$(trkchar(itrk),i,1))*256
      i=i+1
      auxt=auxt+asc(mid$(trkchar(itrk),i,1)) 'duree noire microsec
      'tempo3=1/(typetempo+256*nbtempo) 'nb ticks/noire
      'tempo2=1000*tempo3*auxt/1000000 'duree tick ms
      tempo2=tempo3*auxt/1000.0 'duree tick ms
      auxt0=auxt
      'dprintmsg "tempo tempo2=" &tempo2
      tt1=tt+10000
   end if
   if chr1=88 and chr2=4 then  'metronome
      metro2i=metro2i+1
      vu=1
      i=i+1
      Var nn=asc(mid$(trkchar(itrk),i,1))
      i=i+1
      Var dd=asc(mid$(trkchar(itrk),i,1))
      i=i+1
      Var cc=asc(mid$(trkchar(itrk),i,1))
      i=i+1
      Var bb=asc(mid$(trkchar(itrk),i,1))
      Var temponote=(cc and 63)*bb
      ssss="metro="+str$(nn)+","+str$(dd)+","+str$(temponote)+"/"
      ssss=ssss+str$(metro2i)
      dprintmsg "metronome tempo2=" &tempo2
      tt1=tt+10000
   end if
   if chr1=0 and chr2=2 then  'sequence
      vu=1
      i=i+1
      dprintmsg "sequence"
      dprintmsg mid$(trkchar(itrk),i,1) &"/"
      i=i+1
      dprintmsg mid$(trkchar(itrk),i,1)
   end if
   if chr1=84 and chr2=5 then  'offset
      vu=1
      i=i+1
      offset=offset+1
      'ssss=mid$(trkchar(itrk),i,5)+"  "+str$(issss)
      dprintmsg "offset=" & offset  
      Var hh=asc(Mid$(trkchar(itrk),i,1))
      i=i+1
      Var mn=asc(Mid$(trkchar(itrk),i,1))
      i=i+1
      Var ss=asc(mid$(trkchar(itrk),i,1))
      i=i+1
      Var fr=asc(mid$(trkchar(itrk),i,1))
      i=i+1
      Var ff=asc(mid$(trkchar(itrk),i,1))
      dprintmsg "hhmnss=" & hh &":" & mn &":" & ss &" fr=" & fr &" ff=" & ff
      dprintmsg
   end if
   if vu=0 then
      i=i+chr2
   end if
   if i<ltrk then goto nextchunk
end if

if code=246 or _ 'tunerequest
   code=248 or _ 'time clock
   code=250 or _ 'start
   code=251 or _ 'continue
   code=252 or _ 'stop
   code=254 then 'active sense
   inconnu=0
   if i<ltrk then goto nextchunk
end if

if code240=176 then 'control
   inconnu=0
   i=i+1
   chr1=asc(mid$(trkchar(itrk),i,1))
   i=i+1
   chr2=asc(mid$(trkchar(itrk),i,1))
   if chr1=123 then
      allnoteoff=allnoteoff+1
'      dprintmsg "allnoteoff canal=" &canal
      'outmidi=chr2*256*256+chr1*256+code
      outmidi2
      'nbnote=nbnote-nbnote(canal)
      'nbnote(canal)=0
      /'for auxnote=1 to 127
          if play(auxnote,canal)>0 then
           outmidi=0+auxnote*256+128+canal
           gosub [outmidi] 'par securite
           play(auxnote,canal)=0
          end if
      next auxnote '/
   end if
   if chr1=64 then 'sustain
      'outmidi=chr2*256*256+chr1*256+code
      outmidi2()
   end if
   if chr1=07 then 'volume
      'volcanal(canal)=(chr2/127)
'      dprintmsg "canal=" &canal &"  volume=" &chr2
   end if
   if i<ltrk then goto nextchunk
end if

if code=240 then  'sysex
   inconnu=0
   i=i+1
   'chr1=asc(mid$(trkchar(itrk),i,1))
   i=i+1
   chr2=asc(mid$(trkchar(itrk),i,1))
   while chr2<>247 and i<ltrk 'fin sysex
   i=i+1
   chr2=asc(mid$(trkchar(itrk),i,1))
   wend
   if i<ltrk then goto nextchunk
end if

if code=160 or _    'polyaftertouch
   code240=224 or _ 'pitchbend
   code=242 then    'songpointeur
   inconnu=0
   i=i+1
   'chr1$=mid$(trkchar(itrk),i,1)
   i=i+1
   'chr2$=mid$(trkchar(itrk),i,1)
   if i<ltrk then goto nextchunk
end if

if code240=192 or _ 'progchange
   code240=208 or _ 'aftertouch
   code=243 then    'songselect
   inconnu=0
   i=i+1
   if code240=192 then
      chr1=asc(mid$(trkchar(itrk),i,1))
      instrcanal(canal)=chr1+1
      if instrument=0 then 'default
         'outmidi=0*256*256+chr1*256+code
         outmidi2()
      end if
   end if
   if i<ltrk then goto nextchunk
end if

erreur=erreur+inconnu

if inconnu=1 then
  nberreur=nberreur+1
  code0=code
  dprintmsg "erreur " &erreur
  dprintmsg "code inconnu : " &code0
  dprintmsg "erreur " &nberreur &" code inconnu :" &code0
  'tt2=tt+10000
  if nberreur>10 Then'or debug<>0 then
     'gosub [allnoteoff]
     guiconfirm (fic+chr$(13)+"code inconnu "+str$(code0) _
             +" on continue ?","confirm",auxchar)
     if auxchar="no" then
        'guiconfirm "erreur dans le fichier"+chr$(13)+fic _
        '        +chr$(13)+"remove ?" &auxx$
        'if auxx$="yes" then goto [remove]
        Exit Sub
     end if
  end if
  if i<ltrk then goto nextcode
end if

if i<ltrk then goto nextchunk

dprintmsg "fintrk=" &itrk &"  tt=" &tt
nbtrk=nbtrk-1
if auxtrk0<=nbtrk then
   for auxtrk=auxtrk0 to nbtrk
       itrkk(auxtrk)=itrkk(auxtrk+1)
   next auxtrk
end if
ttitrk=ttitrk+1000000
'if openwin2=1 then dprintmsg #win2.msg,"   trk="+str$(nbtrk)+"/"+str$(nbtrk0)
if nbtrk>0 then goto nexttrk

fintrk:

End sub