//-------------------------------------------------------------------------------------------------------
// VST Plug-Ins SDK
// Version 2.4		$Date: 2006/11/13 09:08:27 $
//
// Category     : VST 2.x SDK Samples
// Filename     : vstxsynth.cpp
// Created by   : Steinberg Media Technologies
// Description  : Example VstXSynth
//
// version modified by NGUYEN.Chung for midipiano_chungVSTI (2012)
//
//-------------------------------------------------------------------------------------------------------

#include "vstxsynth.h"

using namespace std;
const string str(double var){ostringstream str;str << var;return str.str();};
//void notice(const string text){MessageBox(NULL,text.c_str(),"notice",MB_OK);};
void notice(const string text){};

HINSTANCE hGetProcIDDLL;
//typedef int (__stdcall * function)(int,int,int,int,int,int,int,int,int,int);
typedef int (__declspec(dllimport) * function)(int,int,int,int,int,int,int,int,int,int);
typedef float (__declspec(dllimport) * functionf)(int,int,int,int,int,int,int,int,int,int);
function plugininit,startpluginmain,closepluginmain,mymidiinproc,myfillvstibuffer;
functionf mypluginproc;
int varptr(const char a$[]) {
    const char *aa$=a$;
    int i=(int)aa$;
    return i;
}
int varptr2(float x) {
    int i=(int)&x;
    return i;
}
extern HINSTANCE hInstance;
char windowname[255]="midipiano_chungVSTI";
void calldll(){
   char dllname[255];char* fbdllname;
   GetModuleFileName(hInstance, dllname, 250);
   dllname[strlen(dllname)-8]=0;//midipiano_chungVSTI.dll -> midipiano_chung/midipiano_chung.dll
   fbdllname=dllname;
   fbdllname=strcat(fbdllname,"/midipiano_chung.dll");
   //notice(fbdllname);
   /* get handle to dll */
   hGetProcIDDLL = LoadLibrary(fbdllname);
   /* get pointer to the function in the dll*/
   FARPROC lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"plugininit");
   /* Define the Function in the DLL for reuse. This is just prototyping the dll's function.
      A mock of it. Use "stdcall" for maximum compatibility.*/
   plugininit = function(lpfnGetProcessID);
   if (plugininit==0){notice("noplugininit");}
   lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"startpluginmain");
   startpluginmain = function(lpfnGetProcessID);
   if (startpluginmain==0){notice("nostartpluginmain");}

   lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"closepluginmain");
   closepluginmain = function(lpfnGetProcessID);
   if (closepluginmain==0){notice("noclosepluginmain");}

   lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"mypluginproc");
   mypluginproc = functionf(lpfnGetProcessID);
   if (mypluginproc==0){notice("nomypluginproc");}

   lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"mymidiinproc");
   mymidiinproc = function(lpfnGetProcessID);
   if (mymidiinproc==0){notice("nomidiinproc");}

   lpfnGetProcessID = GetProcAddress(HMODULE (hGetProcIDDLL),"myfillvstibuffer");
   myfillvstibuffer = function(lpfnGetProcessID);
   if (myfillvstibuffer==0){notice("nomyfillvstibuffer");}

   if (!plugininit || !startpluginmain || !closepluginmain || !mypluginproc){
      plugininit=0;startpluginmain=0;closepluginmain=0;mypluginproc=0;
   }
   /* The actual call to the function contained in the dll */
   //char i$[255];int i=(int)i$;i=varptr(i$);strcpy(i$,fbdll2name);
   //int ret = MyFunction(i,1,1,1,1,1,1,1,1,1);
   if (plugininit){
   notice("plugininit");
   int ret = plugininit(0,0,0,0,0,0,0,0,0,0);
   }
   notice("okinit");
   if (startpluginmain){
   //int ret = startpluginmain(0,0,0,0,0,0,0,0,0,0);
   }
}
int quit=0;
void closedll(){
   if (closepluginmain){
   int ret = closepluginmain(0,0,0,0,0,0,0,0,0,0);
   }
   //Sleep(200);
   /* Release the Dll */
   FreeLibrary(hGetProcIDDLL);
}


//-------------------------------------------------------------------------------------------------------
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	return new VstXSynth (audioMaster);
}

//-----------------------------------------------------------------------------------------
// VstXSynthProgram
//-----------------------------------------------------------------------------------------
VstXSynthProgram::VstXSynthProgram ()
{
	// Default Program Values
	/*fWaveform1 = 0.f;	// saw
	fFreq1     =.0f;
	fVolume1   = .33f;

	fWaveform2 = 1.f;	// pulse
	fFreq2     = .05f;	// slightly higher
	fVolume2   = .33f;
    */
	fVolume    = 0.5f;//.9f;
	vst_strncpy (name, "Basic", kVstMaxProgNameLen);
}

//-----------------------------------------------------------------------------------------
// VstXSynth
//-----------------------------------------------------------------------------------------
VstXSynth::VstXSynth (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, kNumPrograms, kNumParams)
{
	// initialize programs
	programs = new VstXSynthProgram[kNumPrograms];
	for (VstInt32 i = 0; i < 16; i++)
		channelPrograms[i] = i;

	if (programs)
		setProgram (0);

	if (audioMaster)
	{
        //setBlockSize(1024);
        setSampleRate(44100.0f);
        setNumInputs (0);				// no inputs
		setNumOutputs (kNumOutputs);	// 2 outputs, 1 for each oscillator
		canProcessReplacing ();
		isSynth ();
		//setUniqueID ('myVxS2');//('417t')			// <<<! *must* change this!!!!
		setUniqueID ('417t');			// <<<! *must* change this!!!!
	}

    calldll();
	//initProcess ();
	suspend ();
}

//-----------------------------------------------------------------------------------------
UINT timerid=0;
VstXSynth::~VstXSynth ()
{
	quit=1;
    if (timerid){timeKillEvent(timerid);}
	closedll();
	if (programs){
		delete[] programs;
	}
    Sleep(200);
}

//-----------------------------------------------------------------------------------------
void VstXSynth::setProgram (VstInt32 program)
{
	//return;

	if (program < 0 || program >= kNumPrograms)
		return;

	VstXSynthProgram *ap = &programs[program];
	curProgram = program;

	/*fWaveform1 = ap->fWaveform1;
	fFreq1     = ap->fFreq1;
	fVolume1   = ap->fVolume1;

	fWaveform2 = ap->fWaveform2;
	fFreq2     = ap->fFreq2;
	fVolume2   = ap->fVolume2;
    */
	fVolume    = 0.5f;//ap->fVolume;
}

//-----------------------------------------------------------------------------------------
void VstXSynth::setProgramName (char* name)
{
	vst_strncpy (programs[curProgram].name, name, kVstMaxProgNameLen);
}

//-----------------------------------------------------------------------------------------
void VstXSynth::getProgramName (char* name)
{
	vst_strncpy (name, programs[curProgram].name, kVstMaxProgNameLen);
}

//-----------------------------------------------------------------------------------------
void VstXSynth::getParameterLabel (VstInt32 index, char* label)
{
	switch (index)
	{
		/*case kWaveform1:
		case kWaveform2:
			vst_strncpy (label, "Shape", kVstMaxParamStrLen);
			break;

		case kFreq1:
		case kFreq2:
			vst_strncpy (label, "Hz", kVstMaxParamStrLen);
			break;

		case kVolume1:
		case kVolume2: */
		case kVolume:
			vst_strncpy (label, "dB", kVstMaxParamStrLen);
			break;
	}
}

//-----------------------------------------------------------------------------------------
void VstXSynth::getParameterDisplay (VstInt32 index, char* text)
{
	text[0] = 0;
	switch (index)
	{
		/*case kWaveform1:
			if (fWaveform1 < .5)
				vst_strncpy (text, "Sawtooth", kVstMaxParamStrLen);
			else
				vst_strncpy (text, "Pulse", kVstMaxParamStrLen);
			break;

		case kFreq1:		float2string (fFreq1, text, kVstMaxParamStrLen);	break;
		case kVolume1:		dB2string (fVolume1, text, kVstMaxParamStrLen);	break;

		case kWaveform2:
			if (fWaveform2 < .5)
				vst_strncpy (text, "Sawtooth", kVstMaxParamStrLen);
			else
				vst_strncpy (text, "Pulse", kVstMaxParamStrLen);
			break;

		case kFreq2:		float2string (fFreq2, text, kVstMaxParamStrLen);	break;
		case kVolume2:		dB2string (fVolume2, text, kVstMaxParamStrLen);	break;
		*/
		case kVolume:		dB2string (fVolume, text, kVstMaxParamStrLen);	break;
	}
}

//-----------------------------------------------------------------------------------------
void CALLBACK timeproc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
void timeproc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2){
    timerid=0;
	HWND hwin=FindWindow(0,windowname);//"fb_chungVST");
	//notice(str((int)hwin));
	//if (hwin){ShowWindowAsync(hwin,SW_MINIMIZE);}
	if (hwin){SendMessage(hwin,WM_CLOSE,0,0);}
}
void VstXSynth::getParameterName (VstInt32 index, char* label)
{
	switch (index)
	{
		/*case kWaveform1:	vst_strncpy (label, "Wave 1", kVstMaxParamStrLen);	break;
		case kFreq1:		vst_strncpy (label, "Freq 1", kVstMaxParamStrLen);	break;
		case kVolume1:		vst_strncpy (label, "Levl 1", kVstMaxParamStrLen);	break;
		case kWaveform2:	vst_strncpy (label, "Wave 2", kVstMaxParamStrLen);	break;
		case kFreq2:		vst_strncpy (label, "Freq 2", kVstMaxParamStrLen);	break;
		case kVolume2:		vst_strncpy (label, "Levl 2", kVstMaxParamStrLen);	break;
		*/
		case kVolume:
		    if (startpluginmain){int ret=startpluginmain(0,0,0,0,0,0,0,0,0,0);}
            if (timerid){timeKillEvent(timerid);}
            timerid=timeSetEvent(3000,500,timeproc,DWORD(this),TIME_ONESHOT);
			vst_strncpy (label, "Volume", kVstMaxParamStrLen);	break;
	}
}

//-----------------------------------------------------------------------------------------
void VstXSynth::setParameter (VstInt32 index, float value)
{
	VstXSynthProgram *ap = &programs[curProgram];
	switch (index)
	{
		/*case kWaveform1:	fWaveform1	= ap->fWaveform1	= value;	break;
		case kFreq1:		fFreq1 		= ap->fFreq1		= value;	break;
		case kVolume1:		fVolume1	= ap->fVolume1		= value;	break;
		case kWaveform2:	fWaveform2	= ap->fWaveform2	= value;	break;
		case kFreq2:		fFreq2		= ap->fFreq2		= value;	break;
		case kVolume2:		fVolume2	= ap->fVolume2		= value;	break;
		*/
		//case kVolume:		fVolume		= ap->fVolume		= value;	break;
		case kVolume:		fVolume		= ap->fVolume		= 0.5f;	break;
	}
}

//-----------------------------------------------------------------------------------------
float VstXSynth::getParameter (VstInt32 index)
{
	float value = 0;
	switch (index)
	{
		/*case kWaveform1:	value = fWaveform1;	break;
		case kFreq1:		value = fFreq1;		break;
		case kVolume1:		value = fVolume1;	break;
		case kWaveform2:	value = fWaveform2;	break;
		case kFreq2:		value = fFreq2;		break;
		case kVolume2:		value = fVolume2;	break;
		*/
		case kVolume:
    		value = fVolume;	break;
	}
	return value;
}

//-----------------------------------------------------------------------------------------
bool VstXSynth::getOutputProperties (VstInt32 index, VstPinProperties* properties)
{
	if (index < kNumOutputs)
	{
		vst_strncpy (properties->label, "Vstx ", 63);
		char temp[11] = {0};
		int2string (index + 1, temp, 10);
		vst_strncat (properties->label, temp, 63);

		properties->flags = kVstPinIsActive;
		if (index < 2)
			properties->flags |= kVstPinIsStereo;	// make channel 1+2 stereo
		return true;
	}
	return false;
}

//-----------------------------------------------------------------------------------------
bool VstXSynth::getProgramNameIndexed (VstInt32 category, VstInt32 index, char* text)
{
	if (index < kNumPrograms)
	{
		vst_strncpy (text, programs[index].name, kVstMaxProgNameLen);
		return true;
	}
	return false;
}

//-----------------------------------------------------------------------------------------
bool VstXSynth::getEffectName (char* name)
{
	//vst_strncpy (name, "VstXSynth", kVstMaxEffectNameLen);
	vst_strncpy (name, "midipiano_chungVSTI", kVstMaxEffectNameLen);
	return true;
}

//-----------------------------------------------------------------------------------------
bool VstXSynth::getVendorString (char* text)
{
//	vst_strncpy (text, "Steinberg Media Technologies", kVstMaxVendorStrLen);
	vst_strncpy (text, "NGUYEN.Chung", kVstMaxVendorStrLen);
	return true;
}

//-----------------------------------------------------------------------------------------
bool VstXSynth::getProductString (char* text)
{
//	vst_strncpy (text, "Vst Test Synth", kVstMaxProductStrLen);
	vst_strncpy (text, "Vsti version of midipiano_chung", kVstMaxProductStrLen);
	return true;
}

//-----------------------------------------------------------------------------------------
VstInt32 VstXSynth::getVendorVersion ()
{
	return 1000;
}

//-----------------------------------------------------------------------------------------
VstInt32 VstXSynth::canDo (char* text)
{
	if (!strcmp (text, "receiveVstEvents"))
		return 1;
	if (!strcmp (text, "receiveVstMidiEvent"))
		return 1;
	//if (!strcmp (text, "midiProgramNames"))
	//	return 1;
	return -1;	// explicitly can't do; 0 => don't know
}

//-----------------------------------------------------------------------------------------
VstInt32 VstXSynth::getNumMidiInputChannels ()
{
	return 15; // we are not monophonic
}

//-----------------------------------------------------------------------------------------
VstInt32 VstXSynth::getNumMidiOutputChannels ()
{
	return 0; // no MIDI output back to Host app
}

// midi program names:
// as an example, GM names are used here. in fact, VstXSynth doesn't even support
// multi-timbral operation so it's really just for demonstration.
// a 'real' instrument would have a number of voices which use the
// programs[channelProgram[channel]] parameters when it receives
// a note on message.

//------------------------------------------------------------------------
VstInt32 VstXSynth::getMidiProgramName (VstInt32 channel, MidiProgramName* mpn)
{
	VstInt32 prg = mpn->thisProgramIndex;
	if (prg < 0 || prg >= 128)
		return 0;
	fillProgram (channel, prg, mpn);
	if (channel == 9)
		return 1;
	return 128L;
}

//------------------------------------------------------------------------
VstInt32 VstXSynth::getCurrentMidiProgram (VstInt32 channel, MidiProgramName* mpn)
{
  return 0;
}

//------------------------------------------------------------------------
void VstXSynth::fillProgram (VstInt32 channel, VstInt32 prg, MidiProgramName* mpn)
{
}

//------------------------------------------------------------------------
VstInt32 VstXSynth::getMidiProgramCategory (VstInt32 channel, MidiProgramCategory* cat)
{
	return 0;
}

//------------------------------------------------------------------------
bool VstXSynth::hasMidiProgramsChanged (VstInt32 channel)
{
	return false;	// updateDisplay ()
}

//------------------------------------------------------------------------
bool VstXSynth::getMidiKeyName (VstInt32 channel, MidiKeyName* key)
								// struct will be filled with information for 'thisProgramIndex' and 'thisKeyNumber'
								// if keyName is "" the standard name of the key will be displayed.
								// if false is returned, no MidiKeyNames defined for 'thisProgramIndex'.
{
	// key->thisProgramIndex;		// >= 0. fill struct for this program index.
	// key->thisKeyNumber;			// 0 - 127. fill struct for this key number.
	key->keyName[0] = 0;
	key->reserved = 0;				// zero
	key->flags = 0;					// reserved, none defined yet, zero.
	return false;
}

float t=0;
//-----------------------------------------------------------------------------------------
void VstXSynth::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//if (noteIsOn)
	{
	float* out1 = outputs[0];
	float* out2 = outputs[1];
	float  gain=0.5f;//fVolume;
    if (myfillvstibuffer && quit==0){myfillvstibuffer((int)out1,(int)out2,sampleFrames,(int)&gain,0,0,0,0,0,0);}
	}
	/*
	float* out1 = outputs[0];
	float* out2 = outputs[1];
    float sample1,sample2;
    int i1,i2;

	if (noteIsOn)
	{
		// loop
    while (--sampleFrames >= 0)
	  {
       if (mypluginproc){
		 t+=1.0f;
         sample1=10.f*cos(t/100.0f);
         sample2=10.f*cos(t/100.0f);
         i1=(int)&sample1;//i1=varptr(sample1);
         i2=(int)&sample2;//i2=varptr(sample2);
         (*out1++) = mypluginproc(i1,0,0,0,0,0,0,0,0,0);
         (*out2++) = mypluginproc(i2,0,0,0,0,0,0,0,0,0);
          }
		}
	}
	else
	{
		memset (out1, 0, sampleFrames * sizeof (float));
		memset (out2, 0, sampleFrames * sizeof (float));
	}
	*/
}

//-----------------------------------------------------------------------------------------
VstInt32 VstXSynth::processEvents (VstEvents* ev)
{
	for (VstInt32 i = 0; i < ev->numEvents; i++)
	{
		if ((ev->events[i])->type != kVstMidiType)
			continue;

		VstMidiEvent* event = (VstMidiEvent*)ev->events[i];
		char* midiData = event->midiData;
		VstInt32 status = midiData[0] & 0xf0;	// ignoring channel
		if (status == 0x90 || status == 0x80)	// we only look at notes
		{
			VstInt32 note = midiData[1] & 0x7f;
			VstInt32 velocity = midiData[2] & 0x7f;
			if (status == 0x80)
				velocity = 0;	// note off by velocity 0
			if (!velocity && (note == currentNote))
				noteOff ();
			else
				noteOn (note, velocity, event->deltaFrames);
				//notice("noteon");
		}
		else if (status == 0xb0)
		{
			if (midiData[1] == 0x7e || midiData[1] == 0x7b)	// all notes off
				noteOff ();
		}
    int midimsgok=0;
    switch(midiData[0] & 0xf0){ //status byte (all channels)
      case 0x80: //note off
        midimsgok=1;
        break;
      case 0x90: //note on
        midimsgok=1;
        break;
      case 0xB0: //controller
        midimsgok=1;
        break;
      case 0xC0: //program change
        midimsgok=1;
        break;
       }
       if (midimsgok==1){
          if (mymidiinproc){
              int ret = mymidiinproc((int)&midiData[0],0,0,0,0,0,0,0,0,0);
           }
       }
		event++;
	}
	return 1;
}

//-----------------------------------------------------------------------------------------
void VstXSynth::noteOn (VstInt32 note, VstInt32 velocity, VstInt32 delta)
{
	currentNote = note;
	currentVelocity = velocity;
	currentDelta = delta;
	noteIsOn = true;
	fPhase1 = fPhase2 = 0;
}

//-----------------------------------------------------------------------------------------
void VstXSynth::noteOff ()
{
	noteIsOn = false;
}

void VstXSynth::setSampleRate (float sampleRate)
{
	AudioEffectX::setSampleRate (sampleRate);
}

//-----------------------------------------------------------------------------------------
void VstXSynth::setBlockSize (VstInt32 blockSize)
{
	AudioEffectX::setBlockSize (blockSize);
	// you may need to have to do something here...
}


